/*
	Copyright 2006 EarthLink, Inc. All rights reserved.
*/


/* start user preferences */
PRELOAD_PRODUCT_IMAGES = true;
ZIP_CODE=null;
DO_NOT_COMINGLE=true;
/* end user preferences */

/* start localizable stuff */
/* todo: add more here */
REFINE_SEARCH_BLURB = "Fine-tune your search: ";//"Recommendations ...";
REFINE_SEARCH_BLURB_END = " items found";
REFINE_SEARCH_BLURB_SINGULAR_END = " item found";
GET_OFFERS_BUTTON_TEXT = "Get Offers";
RELOAD_BUTTON_TEXT = "REFRESH";
TIME_LEFT_TEXT = "Time left: ";
UPGRADE_LINK_TEXT = "Click here to upgrade ...";
TRY_AGAIN_LINK_TEXT = "Try Again?";
NO_PURCHASE_INFO_DEFAULT_TEXT = "Check site";
OFFERED_BY = "Offered by: ";
POWERED_BY = "From ";
PRODUCT_DETAIL_TITLE_BLURB = "Click here for more information on this product.";
/* end localizable stuff */

/* start application configuration */

THIS_SOFTWARE_VERSION=0.107;
THIS_SERVICE_VERSION=THIS_SOFTWARE_VERSION;
DEBUG_ENABLED=false;
SERVICE_PREFIX = "macminishopper.earthlink.net/sa";
CONFIG_PREFIX= "my.eimg.net/partners/shopping/software/";
CONFIG_CHECK_URL = "http://" + CONFIG_PREFIX + "/mac/widget/config.xml";
SERVICE_URL_START = "http://" + SERVICE_PREFIX + "/shop/";
SERVICE_URL_END = "/v-"+THIS_SERVICE_VERSION+"/features-partners/level-2/mode-shopper";
MAX_CACHED_ITEMS = 20;
CONFIG_CHECK_INTERVAL_HOURS = 1;
CONFIG_CHECK_INTERVAL_MILLIS = CONFIG_CHECK_INTERVAL_HOURS * 60 * 60 * 1000;
ZIP_CODE_KEY = "miniShopperZipCode";
PRELOAD_PRODUCT_IMAGES_KEY = "miniShopperPreloadImages";

CURRENCIES = ["$","$"];
PROVIDERS = [
	null,
	new Provider("kat","EarthLink",0),
	new Provider("ebay","eBay",2),
	new Provider("amazon","Amazon.com",4,false,true,"-","http://images.amazon.com/images/G/01/x-locale/common/customer-reviews/stars-",".gif"),
	new Provider("sdc","Shopping.com",1,true,true,"","http://img.shopping.com/sc/mr/sdc_checks_",".gif"),
	new Provider("related","Related",0),
	new Provider("yahoo","Yahoo! Stores",3,false)
];

function Provider(shortName,longName,rank,stripZero,hasRatingImage,ratingDecimalSubstitute,ratingImgUrlStart,ratingImgUrlEnd) {
	this.shortName = shortName;
	this.longName = longName;
	this.rank = rank;
	this.hasRatingImage = hasRatingImage;
	this.stripZero = stripZero;
	if (this.hasRatingImage) {
		this.ratingDecimalSubstitute = ratingDecimalSubstitute;
		this.ratingImgUrlStart = ratingImgUrlStart;
		this.ratingImgUrlEnd = ratingImgUrlEnd;
	}
}//Provider object

MAX_IMAGE_WIDTH = 190;
MAX_IMAGE_HEIGHT = 320;
MINIMAL_SIGNIFICANT_MILLISECONDS = 5000;
MAX_SUGGESTION_MENU_TITLE_LENGTH = 80; /* 50 */
MAX_TRUNCATED_TITLE_LENGTH = 50;
MAX_TRUNCATED_TITLE_DETAIL_VIEW_LENGTH = 60; /* 80 */
DETAIL_VIEW_TITLE_TRUNCATE_IF_DESC_LENGTH = 200;
MAX_DETAIL_VIEW_CONTENT_LENGTH_BEFORE_TITLE_TRUNCATING = 500;
MIN_MEANINGFUL_DESCRIPTION_LENGTH = 50;
DEFAULT_LISTING_HEIGHT = 330;
MINIMUM_REVIEW_SUMMARY_LENGTH = 25;
FIXED_DETAIL_VIEW_HEIGHT_ADDITIVE = 30

ITEM_SELECT_TAG_NAME = "tr";
TEXT_NODE = 3;
CDATA_NODE = 4;

OFFER_STATIC = "static";
OFFER_DYNAMIC = "dynamic";
OFFER_MULTIPLE = "multiple";


/* end application configuration */

window.onfocus = function () {
//	$('search-input').focus(); <- overkill
	checkConfig();
}

if (window.widget) {
	widget.onhide = onhide;
	widget.onshow = onshow;
}

function onshow() {
	checkConfig();
}

function onhide() {
	if (glob_req) {
		//glob_req.abort();
		//resetSearchFields();
	}
}

glob_req = null;
glob_searchResults = null;
glob_currentSearch = null;
glob_currentSearchString = null;

glob_searchCache = new Array(); // good ol' associative array, indexed using search strings.
glob_searchCacheCatalog = new Array();

glob_lastConfigCheckTimeStamp = null;
glob_widgetIsOutDated = false;
glob_widgetUpgradeMessageHtmlString = null;
glob_widgetUpgradeUrl = null;

function getSavedPreferences() {
	if (window.widget) {
		//todo: retrieve preferences - DONE !@
		ZIP_CODE = parseInt(widget.preferenceForKey(ZIP_CODE_KEY));
		if (isNaN(ZIP_CODE)) {
			ZIP_CODE = null;
			$("zipCodeInput").value = "";
		} else {
			$("zipCodeInput").value = ZIP_CODE;
		}
		PRELOAD_PRODUCT_IMAGES = widget.preferenceForKey(PRELOAD_PRODUCT_IMAGES_KEY);

		if (PRELOAD_PRODUCT_IMAGES || (PRELOAD_PRODUCT_IMAGES == null))
			$("preloadImagesInput").checked = true;
		else
			$("preloadImagesInput").checked = false;
	}//if in widget-land
}//getSavedPreferences

function reflectPreferences() {
	ZIP_CODE = parseInt($("zipCodeInput").value);
	if (isNaN(ZIP_CODE)) {
		ZIP_CODE = null;
	} else {
		if (window.widget) {
			widget.setPreferenceForKey(ZIP_CODE,ZIP_CODE_KEY);
		}
	}
	PRELOAD_PRODUCT_IMAGES = $("preloadImagesInput").checked;
		if (window.widget) {
			widget.setPreferenceForKey(PRELOAD_PRODUCT_IMAGES,PRELOAD_PRODUCT_IMAGES_KEY);
		}
}//reflectPreferences()

function clearCache() {
	glob_searchCache = new Array();
	glob_searchCacheCatalog = new Array();
}//clearCache

function getNormalizedString(s,keepCase) {
	if (!keepCase) s = s.toLowerCase();
	return s.replace(/[ \r\n\r\t\f\s]+/g,' ').replace(/^[ \r\n\r\t\f\s]+/g,'').replace(/[ \r\n\r\t\f\s]+$/g,'');
}//getNormalizedString

function populateCache(searchString, rObj) {
	rObj.timeStamp = (new Date()).getTime();
	glob_searchCache[searchString] = rObj;
	
	glob_searchCacheCatalog.push(searchString);
	if (glob_searchCacheCatalog.length > MAX_CACHED_ITEMS) removeLastCacheEntry();
}//populateCache

function removeLastCacheEntry() {
	cacheKey = glob_searchCacheCatalog.shift();
	delete glob_searchCache[cacheKey];
}//removeLastCacheEntry

function getCachedResultSet(searchString) {
	return glob_searchCache[searchString];
}//getCachedResultSet

function getCacheableResults(searchString,url,doNotRetrieveFromCache) {
	searchString = getNormalizedString(searchString);
	glob_currentSearchString = searchString;
	if (!doNotRetrieveFromCache && (testResults = getCachedResultSet(searchString))) {
		glob_searchResults = testResults;
		setTimeout("displaySearchResults();resetSearchFields();",100);
	} else {
		getResultsFromNetwork(url);
	}
}//getCacheableResults

function getResultsFromNetwork(url,isConfigCheck) {
	/* 
		only spawn a new request if the variable glob_req IS null
		if it's not null, it's currently being used by an existing request.
		when that request completes, it will be set to null again.
	*/
    if (!glob_req && window.XMLHttpRequest) {
        glob_req = new XMLHttpRequest();
        glob_req.isConfigCheck = isConfigCheck;
        glob_req.open("GET", url, true);
        glob_req.onreadystatechange = processReqChange;
        glob_req.send(null);
    } else {
    	setError("The service is busy, please try again in a bit.");
    }
}//getResultsFromNetwork

function processReqChange() {
	if (glob_req.readyState == 0) {
		setStatus("initializing ... ");
	} else if (glob_req.readyState == 1) {
		setStatus("loading ... ");
	} else if (glob_req.readyState == 2) {
		setStatus("loaded ... ");
	} else if (glob_req.readyState == 3) {
		setStatus("interactive ... ");
	} else if (glob_req.readyState == 4) {
		if (!glob_req.isConfigCheck) {
			if (glob_req.status == 200) {
				glob_searchResults = glob_req.responseXML;
				populateCache(glob_currentSearchString,glob_searchResults);
				displaySearchResults();
				resetSearchFields();
			} else {
				setError("The service is currently unreachable.");
				resetSearchFields();
			}
		} else {
			processConfigUpdate();
			resetSearchFields();
		}
	}//if readystate is 4
}//processReqChange

function resetSearchFields() {
	glob_currentSearchString = null;
	glob_searchResults = null;
	glob_req = null;
}//resetSearchFields

function getResultObjectFromNode(n) {
	res = null;
	while (n && !res) {
		if (n.result) res = n.result;
		n = n.parentNode;
	}
	return res
}//getResultObjectFromNode

function getOfferObjectFromNode(n) {
	off = null;
	while (n && !off) {
		if (n.offer) off = n.offer;
		n = n.parentNode;
	}
	return off;
}//getOfferObjectFromNode

function showSelectedItemInfo(menuObj) {
	if (menuObj && menuObj.selectedIndex && (menuObj.selectedIndex != 0) && (menuObj.selectedIndex != -1)) {
		showDetailView(menuObj.options[menuObj.selectedIndex]);
	}
}//showSelectedItemInfo

function showDetailView(refObject) {
	r = getResultObjectFromNode(refObject);
	o = getOfferObjectFromNode(refObject);
	fc = $("buy").firstChild;
	if (r) {
		goToDetailMode();
		if (fc) $("buy").removeChild(fc);
		detailView = r.getDetailView(o,refObject);
		detailView = $("buy").appendChild(detailView);

		detailView.descriptionRef.parentNode.style.height =	
		(
			parseInt(document.defaultView.getComputedStyle(detailView.contentRef).getPropertyValue("height"))
			-
			(
				detailView.headerStuffRef.offsetHeight +
				detailView.buyboxRef.offsetHeight +
				detailView.detailViewVendorDisplayRef.offsetHeight + 
				FIXED_DETAIL_VIEW_HEIGHT_ADDITIVE) 
		) + "px";
		
		setupScrolling($$mc("div","scroll",detailView)[0],"infoBoxScrollBar");
	} else {
		alert("no item data found");
	}
	if (scrollAreas["listContainerVerticalScrollBar"]) scrollAreas["listContainerVerticalScrollBar"].refresh();
	return false;
}//showDetailView

function goToOffer(offer) {
	if (offer) {
		if (window.widget && offer.url) {
			widget.openURL(offer.url.replace(/\^/gi,'%5E'));
		} else if (offer.url) {
			window.open(offer.url,"");
		}
	}
}//goToOffer

function toggleMiddleContent(togLink) {
	c = togLink.className;

	if (c && (c.indexOf("isShowingDescription") != -1) ) {
		if (togLink.descriptionObject && togLink.reviewsObject) {
			unsetClassValue(togLink,"isShowingDescription");
			togLink.descriptionObject.style.display = "none";
			togLink.reviewsObject.style.display = "block";
			setClassValue(togLink,"isShowingReviews");
		}
	} else if (c) {
		if (togLink.descriptionObject && togLink.reviewsObject) {
			unsetClassValue(togLink,"isShowingReviews");
			togLink.reviewsObject.style.display = "none";
			togLink.descriptionObject.style.display = "block";
			setClassValue(togLink,"isShowingDescription");
		}
	}//className is at least set
	
	scrollAreas["infoBoxScrollBar"].refresh();
}//toggleMiddleContent

function processPurchaseOffer(o,offersListReference,resultObj) {
	tr = $e("tr");

	if (PRELOAD_PRODUCT_IMAGES) {
		if (o.product.visual && o.product.visual.url && !o.product.visual.imagesArePreloaded) {
			o.product.visual.preloadImages();
		}//preload images if visual information is there
	}//preload images for the product, if the preference is set

	if (o.product.title != o.product.truncatedTitle) {
		tr.setAttribute("title",o.product.title);
	}//show tooltip if we truncated the title

	pid=0;
	if (!isNaN(pid=parseInt(resultObj.sourceId)));
	partner = PROVIDERS[pid];

	priceCell = tr.appendChild($e("td"));
	partnerImage = priceCell.appendChild($e("img"));
	partnerImage.setAttribute("src","./img/partner_" + resultObj.sourceId + "_logo.png");

	if (partner) {
		partnerImage.setAttribute("alt",POWERED_BY + partner.longName);
		partnerImage.setAttribute("title",POWERED_BY + partner.longName);
	} else {
		partnerImage.setAttribute("alt",POWERED_BY + resultObj.sourceLongName);
		partnerImage.setAttribute("title",POWERED_BY + resultObj.sourceLongName);
	}
	
	lineBreak = priceCell.appendChild($e("br"));
	setClassValue(partnerImage,"partnerImage");
	setClassValue(partnerImage,"partnerImage_" + partner.shortName);
	price = priceCell.appendChild(o.getPriceInfo());
	setClassValue(priceCell,"priceInfo");
	priceCell.setAttribute("nowrap","nowrap");
	priceCell.offer = o;
	
	offerTitleCell = tr.appendChild($e("td"));
	titleBlock = $e("div");
	setClassValue(titleBlock,"titleBlock");
	titleBlock = offerTitleCell.appendChild(titleBlock);
	titleBlock = titleBlock.appendChild($e("span"));

	title = titleBlock.appendChild($t(o.product.truncatedTitle));
	setClassValue(offerTitleCell,"offerTitle");
	
	checkBox = titleBlock.appendChild($e("input"));
	checkBox.setAttribute("type","checkbox");
	setClassValue(checkBox,"itemCheckBox");
	
	tr = offersListReference.appendChild(tr);

	setClassValue(tr,"actualOffer");
	
	tr.result = resultObj;
	tr.offer = o;
}//processPurchaseOffer

function processSuggestionOffer(o,suggestionsListReference,resultObj) {
	item = $e("option");
	item.setAttribute("value",o.product.title);
	item.setAttribute("title",o.product.title);
	
	offerTitleCell = item.appendChild($e("span"));
	title = offerTitleCell.appendChild(o.getOfferTitleTruncated());
	setClassValue(offerTitleCell,"offerTitle");

	isHighRankingOffer = false;
	isSameAsSearch = false;
	offerTitleText = resultObj.product.titleHash;
	titleIsSameAsPreviousEntry =
		(
			(
				suggestionsListReference.firstChild
				&&
				suggestionsListReference.firstChild.nextSibling
				&&
				suggestionsListReference.firstChild.nextSibling.result
				&&
				(offerTitleText == suggestionsListReference.firstChild.nextSibling.result.product.titleHash)
			)
			||
			(
				suggestionsListReference.lastChild
				&&
				suggestionsListReference.lastChild.result
				&&
				(offerTitleText == suggestionsListReference.lastChild.result.product.titleHash)
			)
		)
	
	if (offerTitleText == glob_currentSearchString) {
		isSameAsSearch = true
	} else if (offerTitleText.indexOf(glob_currentSearchString) != -1) {
		isHighRankingOffer = true;
	}
	
	if (!isSameAsSearch && !titleIsSameAsPreviousEntry) {

		item = suggestionsListReference.appendChild(item);
		setClassValue(item,"productSuggestion");

		if (isHighRankingOffer) {
			setClassValue(item,"highRanking");
		}
		item.result = resultObj;
	}//don't insert an item whose title is the exact same as the search, as a suggestion - it's redundant
}//processSuggestionOffer

function renderDetailView(detailViewContainerReference, resultObj, offerObj, rowReference) {

	if (cm) cm.hideMenuTimer = setTimeout('killCM()',100);

	dvcr = detailViewContainerReference; //heh.
	r = resultObj;//heh
	o = offerObj;//heh
	
	partnerInteger = parseInt(r.sourceId);
	partner = PROVIDERS[partnerInteger];
	
	content = $$mc("div","content",dvcr)[0];
	content.rowRef = rowReference;
	content.setAttribute("onclick","selectItem(this.rowRef);scrollAreas['listContainerVerticalScrollBar'].refresh()");
	content.result = r;
	content.offer = o;
	
	headerStuff = $$mc("div","headerStuff",content)[0];
	visual = $$mc("div","visual",content)[0];
	visual.referenceToContentNode = content;
	visual.referenceToResultObject = r;
	title = $$mc("h3","itemTitle",content)[0];
	infoBox = $$mc("div","infoBox",content)[0];
	description = $$mc("p","description",content)[0];
	reviews = $$mc("p","reviews",content)[0];
	poweredBy = $$mc("div","poweredBy",content)[0];
	
	tog = $$mc("div","reviewsOrDescription",content)[0];
	tog.descriptionObject = description;
	tog.reviewsObject = reviews;
	tog.infoBoxObject = infoBox;
	
	rating = $$mc("div","ratingInfo",content)[0];
	
	buybox = $$mc("div","actions",content)[0];
	purchasing = $$mc("div","purchasing",buybox)[0];
	paction = $$mc("span","action",content)[0];
	pprice = $$mc("span","price",content)[0];
	
	tline = $$mc("div","timeLine",content)[0];
	
	purchaseInfo = $$mc("div","purchasingInformation",content)[0];
	pvisu = $$mc("div","vendorVisual",purchaseInfo)[0];
	pvname = $$mc("div","vendorName",purchaseInfo)[0];
	pvendor = $$mc("table","vendorInfo",purchaseInfo)[0];
	pvrating = $$mc("td","vendorRating",pvendor)[0];
	pvlocation = $$mc("td","vendorLocation",pvendor)[0];
	pvcountry = $$mc("td","vendorCountry",pvendor)[0];
	
	picost = $$mc("table","costInfo",purchaseInfo)[0];
	pricetwo = $$mc("td","pricetwo",picost)[0];
	pizip = $$mc("td","zipcode",picost)[0];
	pitax = $$mc("td","tax",picost)[0];
	piship = $$mc("td","shipping",picost)[0];
	pitotal = $$mc("td","total",picost)[0];
	
	if (r.product.visual && r.product.visual.url) {
		image = visual.appendChild($e("img"));
		image.setAttribute("src", r.product.visual.url);
		if (r.product.visual.width) {
			image.setAttribute("width",r.product.visual.width);
			visual.style.width = (r.product.visual.width + "px");
		}//image width exists

		if (r.product.visual.height) {
			image.setAttribute("height",r.product.visual.height);
		}//
		
		image.setAttribute("alt",r.product.title);
		image.setAttribute("title",r.product.title);
		
		if (r.product.visual.medium_url || r.product.visual.large_url) {
			visual.setAttribute("onclick","zoomImage(this)");
			setClassValue(visual,"visualZoomEnabled");
			visual.setAttribute("title","Click for a larger image");
			magGlass = $$mc("img","magGlass",visual)[0];
			magGlass.style.visibility="visible";
		}
	}//visual info exists in result object

	//r.product.title should always exist, if we got this far.
	titleLink = title.appendChild(getLink(o.url));

	cleanedTitle = getTruncatedString(
				r.product.title,
				MAX_TRUNCATED_TITLE_DETAIL_VIEW_LENGTH,
				(
					!r.product.reviews
					||
					!r.product.reviews.reviewItems
					||
					(r.product.reviews.reviewItems.length == 0)
					&&
					(
				
						!r.product.desc
						||
						(
							r.product.desc &&
							(
								(r.product.desc.length + r.product.title.length) <= MAX_DETAIL_VIEW_CONTENT_LENGTH_BEFORE_TITLE_TRUNCATING
							)
						)
					)
				)		
			);
	titleData = titleLink.appendChild($t(cleanedTitle));
	if (cleanedTitle != r.product.title) {
		title.setAttribute("title",r.product.title + ". " + PRODUCT_DETAIL_TITLE_BLURB);
	} else {
		title.setAttribute("title",PRODUCT_DETAIL_TITLE_BLURB);
	}
	
	/* using .innerHTML to render HTML content stuck in CDATA blocks from the XML feed */
	if (r.product.desc) description.innerHTML = r.product.desc;

	detailViewVendorDisplay = $e("div");
	vendorImage = $e("img");
	if (r.vendor && r.vendor.visual && r.vendor.visual.url) {
		setClassValue(detailViewVendorDisplay,"vendorDisplay");
		if (!r.vendor.visual.imagesArePreloaded) {
			r.vendor.visual.preloadImages();
		}
		vText = detailViewVendorDisplay.appendChild($t(OFFERED_BY));
		vendorImage = detailViewVendorDisplay.appendChild(vendorImage);
		vendorImage.setAttribute("align","middle");
		vendorImage.setAttribute("src",r.vendor.visual.url);
		if (r.vendor.name) {
			vendorImage.setAttribute("title",OFFERED_BY + r.vendor.name);
		}
	} else if (r.vendor && r.vendor.name) {
		setClassValue(detailViewVendorDisplay,"vendorDisplay");
		vName = detailViewVendorDisplay.appendChild($e("span"));
		vText = vName.appendChild($t(OFFERED_BY + r.vendor.name));
	}

	detailViewVendorDisplay = description.parentNode.parentNode.parentNode.insertBefore(detailViewVendorDisplay, description.parentNode.parentNode);

	
	if (	
			r.product.reviews
			&&
			(
				(r.product.reviews.summary && (r.product.reviews.summary.length > MINIMUM_REVIEW_SUMMARY_LENGTH) )
				||
				(r.product.reviews.reviewItems && (r.product.reviews.reviewItems.length > 0))
			)
		) {
		//tog.style.display = "block";
		tog.style.visibility = "visibie";
		reviewContent = r.product.reviews.summary;
		if (r.product.reviews.reviewItems && (r.product.reviews.reviewItems.length > 0)) {
			contentBuffer = new StringBuffer();
			for (h=0,even=false;(ri=r.product.reviews.reviewItems[h]);h++) {
				contentBuffer.append('<p class="reviewItem');
				if (even) {
					contentBuffer.append(' isEvenReview');
				}
				contentBuffer.append('">');
				contentBuffer.append(ri);
				contentBuffer.append('</p>');
				even = !even;
			}//loop thru'em, append to buffer
			reviewContent = contentBuffer.toString("");
		}//if some individual reviews exist
		/*
			using innerHTML here again because, like for descriptions,
			much of the review data has HTML embedded as text data, and the
			only way for the browser to parse and render it is to use innerHTML
		*/
		reviews.innerHTML = reviewContent;
	}//if some reviews are available in summary or individual form
	
	if (partner && r.product.rating && r.product.rating.value) {		
			rInfo = new StringBuffer();
			rInfo.append(partner.longName);
			rInfo.append(" rating: ");
			rInfo.append(r.product.rating.value);

			if (partner.hasRatingImage) {
				url1 = partner.ratingImgUrlStart;
				url2 = partner.ratingImgUrlEnd;
				ratingPath = r.product.rating.value;
				if (partner.stripZero) {
					ratingPath = ratingPath.replace(/\.0$/,'');
				}
				ratingPath = ratingPath.replace(/\./g,partner.ratingDecimalSubstitute); 
				piu = new StringBuffer();
				piu.append(url1);
				piu.append(ratingPath);
				piu.append(url2);
				
				//rating.appendChild($t(partner.longName + " rating: "));
				rimg = rating.appendChild($e("img"));
				rimg.setAttribute("src",piu.toString());
				rimg.setAttribute("title",rInfo.toString());
			} else {
				rating.appendChild($t(rInfo.toString()));
			}
	}//if rating info available
	
	if (o.price && (o.type == OFFER_DYNAMIC)) {
		while(paction.firstChild) {
			paction.removeChild(firstChild);
		}
		paction.appendChild($t("Bid: "));
		while(pprice.firstChild) {
			pprice.removeChild(firstChild);
		}
		pprice.appendChild($t(CURRENCIES[o.currencyId] + getFormattedPrice(o.price)));
	} else if (o.price) {
		while(paction.firstChild) {
			paction.removeChild(firstChild);
		}
		paction.appendChild($t("Buy for: "));
		while(pprice.firstChild) {
			pprice.removeChild(firstChild);
		}
		pprice.appendChild($t(CURRENCIES[o.currencyId] + getFormattedPrice(o.price)));	
	}
	
	var hasSomeVendorInfo = false;
	if (r.vendor) {

		if (r.vendor.visual && r.vendor.visual.url) {
			vimg = pvisu.appendChild(vendorImage.cloneNode(true));
			pvisu.style.display = "block";
			pvisu.parentNode.parentNode.style.visibility = "visible";
			hasSomeVendorInfo = true;
		} else if (r.vendor.name) {
			pvname.appendChild($t(r.vendor.name));
			pvname.style.display = "block";
			pvname.parentNode.parentNode.style.visibility = "visible";
			hasSomeVendorInfo = true;
		}//show logo image or name, not both.

		if (partner && r.vendor.rating && r.vendor.rating.value) {
			pvrating.appendChild($t(r.vendor.rating.value));
			pvrating.parentNode.style.display = "table-row";
			hasSomeVendorInfo = true;
		}

		if (r.vendor.locale && r.vendor.locale.zip) {
			pvlocation.appendChild($t(r.vendor.locale.zip));
			pvlocation.parentNode.style.display = "table-row";
			hasSomeVendorInfo = true;
		} else if (r.vendor.locale && r.vendor.locale.country) {
			pvcountry.appendChild($t(r.vendor.locale.country));
			pvcountry.parentNode.style.display = "table-row";
			hasSomeVendorInfo = true;
		}
				
		if (hasSomeVendorInfo) {
			pvendor.style.display="block";
		}
	}//vendor info exists

	hasSomeBuyingInfo = false;

	if (isNaN(parseInt(r.locale))) r.locale = null;

	if (r.locale) {
	
		pricetwo.appendChild($t(CURRENCIES[o.currencyId] + getFormattedPrice(o.price)));
	
		buyingInfo = new StringBuffer();
		if (o.shipping && o.shipping.price && !isNaN(sprice=o.shipping.price)) {

			piship.appendChild($t(CURRENCIES[o.currencyId] + getFormattedPrice(sprice)));

			buyingInfo.append("Shipping costs: ");
			buyingInfo.append(CURRENCIES[o.currencyId]);
			buyingInfo.append(getFormattedPrice(sprice));
			if (o.shipping.type) {
				buyingInfo.append(" (");
				buyingInfo.append(o.shipping.type);
				buyingInfo.append(")");
			}
			buyingInfo.append(", ");
			hasSomeBuyingInfo = true;
		} else {
			if (!o.total) {
				piship.appendChild($t(NO_PURCHASE_INFO_DEFAULT_TEXT));
				piship.parentNode.style.display = "none";
			} else {
				piship.appendChild($t(CURRENCIES[o.currencyId] + "0.00"));
			}
		}
		
		if (o.tax && !isNaN(taxprice=o.tax)) {
			
			pitax.appendChild($t(CURRENCIES[o.currencyId] + getFormattedPrice(taxprice)));
			
			buyingInfo.append("Tax: ");
			buyingInfo.append(CURRENCIES[o.currencyId]);
			buyingInfo.append(getFormattedPrice(taxprice));
			buyingInfo.append(", ");
			hasSomeBuyingInfo = true;
		} else {
			if (!o.total) {
				pitax.appendChild($t(NO_PURCHASE_INFO_DEFAULT_TEXT));
				pitax.parentNode.style.display = "none";
			} else {
				pitax.appendChild($t(CURRENCIES[o.currencyId] + "0.00"));
			}
		}
		
		if (o.total && !isNaN(totalprice=o.total)) {
		
			pitotal.appendChild($t(CURRENCIES[o.currencyId] + getFormattedPrice(totalprice)));
		
			buyingInfo.append("Total Price: ");
			buyingInfo.append(CURRENCIES[o.currencyId]);
			buyingInfo.append(getFormattedPrice(totalprice));
			buyingInfo.append(", ");
			hasSomeBuyingInfo = true;
		} else {
			pitotal.appendChild($t(NO_PURCHASE_INFO_DEFAULT_TEXT));
			pitotal.parentNode.style.display = "none";
		}

		if (hasSomeBuyingInfo) {
			
			pizip.appendChild($t(r.locale));
			picost.style.display="block";
		
			buyingInfo.append(" for Zip Code: ");
			buyingInfo.append(r.locale);
			buyingInfo.append(".");
			/* overkill for now
			could be used for debug info
			buybox.setAttribute("title",buyingInfo.toString());
			*/
		}
	}//locale info present in the service response
	
	if (hasSomeBuyingInfo || hasSomeVendorInfo) {
		setClassValue(purchasing,"cmTrigger");
		purchasing.cmMenu = purchaseInfo;
		setClassValue(purchaseInfo,"cmMenu");
	}
	
	if (o.timeUtc && o.timeUtc.endDate) {
		tline.style.visibility="visible";
		while(tline.firstChild) {
			tline.removeChild(tline.firstChild);
		}

		tlineText = "";

		now = (new Date()).getTime();
		offerEnd = o.timeUtc.endDate.getTime();
		timeDiff = offerEnd - now;
		if (timeDiff <= 0) {
			tlineText = "Offer ended.";
		} else {
			tlineText = "Time left: " + getTimeEllapsedString(timeDiff) ;
		}
		tline.appendChild($t(tlineText));
	}//if end of times exists :o

	if (partner) {
		poweredByText = poweredBy.appendChild($t(POWERED_BY + partner.longName));
	}
	
	dvcr.contentRef = content;
	dvcr.buyboxRef = buybox;
	dvcr.headerStuffRef = headerStuff;
	dvcr.descriptionRef = description;
	dvcr.detailViewVendorDisplayRef = detailViewVendorDisplay;
	dvcr.vendorImageRef = vendorImage;

}//renderDetailView

function displaySearchResults() {
	if (glob_searchResults) {

		setStatus("Formatting ...");
		
		now = (new Date).getTime();
		
		ago = null;
		if (ts = glob_searchResults.timeStamp) {
			ago = now - ts;
		}
		if (ago && (ago > MINIMAL_SIGNIFICANT_MILLISECONDS) && (showTime = getTimeEllapsedString(ago))) ago = " " + showTime + " ago ";
		else ago = "";
			
		results = $$m(glob_searchResults,"result");
		locale = getTextData($$m($$m(glob_searchResults,"search-specific")[0],"generic")[0]);
		
		d = $("pick");
		
		while(d.firstChild) {
			d.removeChild(d.firstChild);
		}
		
		resultGroup = $e("div");
		resultGroup.className="resultGroup";
		resultGroup.results = results;
		resultGroup = d.appendChild(resultGroup);
		
		suggestionDiv = $e("div");
		suggestionDiv.setAttribute("id","suggMenuContainer");
		suggestionDiv.className = "suggestions";
		suggestionDiv = resultGroup.appendChild(suggestionDiv);
		suggestionDiv.style.display = "none";
		
		selectionTextDiv = $e("div");
		selectionTextDiv.className = "currentSelectionText";
		//selectionTextDiv.appendChild($t(REFINE_SEARCH_BLURB));
		//moved this part below
		selectionTextDiv = suggestionDiv.appendChild(selectionTextDiv);
		
		suggestionsList = $e("select");
		suggestionsList.choiceDisplayDiv = selectionTextDiv; 
		suggestionsList.className = "suggestionsList";
		suggestionsList.setAttribute("id","suggestionMenu");
		suggestionsList.setAttribute("onchange","menuRefineSearch(this)");
		suggestionsList.setAttribute("onfocus","this.isFocused=true");
		suggestionsList.setAttribute("onblur","this.isFocused=false");
		suggestionsList = suggestionDiv.appendChild(suggestionsList);
		
		defaultOption = $e("option");
		defaultOption.value = "";
		defOptText = defaultOption.appendChild($t(REFINE_SEARCH_BLURB));
		defaultOption = suggestionsList.appendChild(defaultOption);
		
		title = resultGroup.appendChild($e("h3"));
		if (ago) {
			agoRow = $e("span");
			setClassValue(agoRow,"timeAgo");
			ago = agoRow.appendChild($t(ago + " - "));
			agoRow = title.appendChild(agoRow);
			
			refreshButton = $e("button");
			setClassValue(refreshButton,"refreshButton");
			setClassValue(refreshButton,"actionButton");
			refreshButton.setAttribute("onclick","refreshData(this)");
			buttonText = refreshButton.appendChild($t(RELOAD_BUTTON_TEXT));
			refreshButton = title.appendChild(refreshButton);
		}
		
		listContainer = $e("div");
		setClassValue(listContainer,"listContainer");
		listContainer = resultGroup.appendChild(listContainer);

		offersList = listContainer.appendChild($e("table"));
		offersList.setAttribute("cellspacing","0");
		offersList.className = "listView";

		rankOneOffers = new Array();
		r1oCount = 0;
		rankTwoOffers = new Array();
		r2oCount = 0;
		
		sortedPurchaseOffers = new Array();
		spoCount = 0;
		
		sortedSuggestions = new Array();
		suggCount = 0;

		for (rcount=0; results && results[rcount] && (r=new ShoppingResult(results[rcount])); rcount++) {
			soffers = r.product.pricing.offers;
			r.locale = locale;
			for (offCount=0; soffers && (so=soffers[offCount]);offCount++) {
				so.resultReference = r;
				if (so.price || (so.priceRange && so.priceRange.exists && (so.priceRange.min == so.priceRange.max))) {
					if (
							!DO_NOT_COMINGLE
							&&
							(r.product.titleHash == glob_currentSearchString)
						) {
						so.rank = 1;
						rankOneOffers[r1oCount] = so;
						r1oCount++;
					} else if	(
									!DO_NOT_COMINGLE
									&&
									(
										(r.product.titleHash.indexOf(glob_currentSearchString) != -1)
										||
										(glob_currentSearchString.indexOf(r.product.titleHash) != -1)
									)
								) {
						so.rank = 2;
						rankTwoOffers[r2oCount] = so;
						r2oCount++;
					} else {
						so.rank = 5;
						sortedPurchaseOffers[spoCount] = so;
						spoCount++;
					}
				} else if (so.priceRange && so.priceRange.exists) {
					sortedSuggestions[suggCount] = so;
					suggCount++;
				}//if price vs priceRange exists
			}//loop thru offers for given result		
		}//loop thru results
		
		rankOneOffers.sort(sortByOffer);
		rankTwoOffers.sort(sortByOffer);
		sortedPurchaseOffers.sort(sortByOffer);
		sortedSuggestions.sort(sortByName);

		for (q=0;ssugg=sortedSuggestions[q];q++) {
			processSuggestionOffer(ssugg,suggestionsList,ssugg.resultReference);
		}//loop thru suggestions
		
		for (v=0;spo=rankOneOffers[v];v++) {
			processPurchaseOffer(spo,offersList,spo.resultReference);
		}//loop thru purchase offers
		
		for (v=0;spo=rankTwoOffers[v];v++) {
			processPurchaseOffer(spo,offersList,spo.resultReference);
		}//loop thru purchase offers
		
		for (v=0;spo=sortedPurchaseOffers[v];v++) {
			processPurchaseOffer(spo,offersList,spo.resultReference);
		}//loop thru purchase offers
		
		lcHeight = DEFAULT_LISTING_HEIGHT;

		if (ago) {
			lcHeight -=25;
		}//if "time ago" was inserted, shrink height of content area by 20px;
		
		if (suggestionsList.childNodes.length > 1) {
			count = (suggestionsList.childNodes.length - 1);
			if (count != 1) {
				selectionTextDiv.appendChild($t(REFINE_SEARCH_BLURB));
				selTextSpan = selectionTextDiv.appendChild($e("span"));
				selTextSpan.setAttribute("class","itemsFound");
				itemFoundText = selTextSpan.appendChild($t(count + REFINE_SEARCH_BLURB_END));
			} else if (count == 1) {
				selectionTextDiv.appendChild($t(REFINE_SEARCH_BLURB));
				selTextSpan = selectionTextDiv.appendChild($e("span"));
				selTextSpan.setAttribute("class","itemsFound");
				itemFoundText = selTextSpan.appendChild($t(count + REFINE_SEARCH_BLURB_SINGULAR_END));			
			}
			suggestionDiv.style.display = "block";
			lcHeight -= 25;
		}//if suggestions were populated, show the pull-down menu

		listContainer.style.height = (lcHeight + "px");

		if (results && (results.length > 0)) {
			setupScrolling(listContainer,"listContainerVerticalScrollBar");
		} else {
			setError('No items matching ' + glob_currentSearch + ' were found. ');
		}

	}//glob_searchResults not null
	clearStatus();
}//displaySearchResults

scrollBars = new Array();
scrollAreas = new Array();

function setupScrolling(refScrollContainer, containerClass) {
	if (window.widget) {
		scrollBarDiv = null;
		scrollBarDiv = refScrollContainer.parentNode.appendChild($e("div"));
		setClassValue(scrollBarDiv,containerClass);
		
		scrollAreas[containerClass] = new AppleScrollArea(refScrollContainer);
		scrollBars[containerClass] = new AppleVerticalScrollbar(scrollBarDiv);
		
		scrollAreas[containerClass].addScrollbar(scrollBars[containerClass]);
	} else {
		refScrollContainer.style.overflow="auto";
	}
}//setupScrolling

function refreshData(bObj) {
	search($('search-input'),true);
}//refreshData

function menuRefineSearch(menuObj) {
	if (cdd=menuObj.choiceDisplayDiv) {
		cdd.innerText = menuObj.options[menuObj.selectedIndex].value;
	}
	refineSearch(menuObj.options[menuObj.selectedIndex].value);
}//menuRefineSearch

function refineSearch(refinedSearch) {
	if (refinedSearch) {
		$("search-input").value = refinedSearch;
		$("searchForm").submit();//adds refined search to history. evil hack.
		search($("search-input"));
	}
}//refineSearch

function search (input,doNotRetrieveFromCache)
{
	
	reflectPreferences();

	var value = input.value;
	if (!glob_widgetIsOutDated && value && (value.length > 0)) {
		setStatus("Searching ...");		
		setLoadingStatus();
		goToListMode();
		glob_currentSearch = value;
		searchValue = encodeURIComponent(getNormalizedString(value));
		url = new StringBuffer();
		url.append(SERVICE_URL_START);
		url.append(searchValue);
		url.append(SERVICE_URL_END);
		if (ZIP_CODE) {
			url.append("/locale-");
			url.append(ZIP_CODE);
		}
		url = url.toString();
		getCacheableResults(searchValue, url, doNotRetrieveFromCache);
	}//if value is in the form
	else if (glob_widgetIsOutDated) {
		showUpgradeNotice();
	} else {
		goToBasicView();
	}
}//perform t3h search whenever onsearch event fired.

function clearStatus() {
	$("status").style.visibility="hidden";
}//clearStatus

function setStatus(s) {
	debug(s);
	//$("status").style.visibility="visible";
}//setStatus

function setLoadingStatus() {
	d = $("pick");
	stat = $("pickStatus");
	while(d.firstChild) {
		d.removeChild(d.firstChild);
	}
	stat = d.appendChild(stat.cloneNode(true));
	stat.removeAttribute("id");
}//setLoadingStatus

function setError(msg,size,upgradeNodeString,upgradeUrl) {
	d = $("pick");
	err = $("errorMessage");
	while(d.firstChild) {
		d.removeChild(d.firstChild);
	}
	err = d.appendChild(err.cloneNode(true));
	err.removeAttribute("id");
	if (!upgradeNodeString) {
		etext = err.appendChild($t(msg));
		tryAgainLink = err.appendChild($e("a"));
		tryAgainLink.setAttribute("href","#");
		tryAgainLink.setAttribute("onclick","refreshData(this);return false;");
		talText = tryAgainLink.appendChild($t(TRY_AGAIN_LINK_TEXT));
		} else {
		err.style.marginTop = "20px";
		err.innerHTML = upgradeNodeString;
		if (upgradeUrl) {
			ulink = err.appendChild(getLink(upgradeUrl));
			setClassValue(ulink,"upgradeUrl");
			ulinkText = ulink.appendChild($t(UPGRADE_LINK_TEXT));
		}
	}//upgrade info is present
	//setupScrolling(d,"errorBoxVerticalScrollBar");
}//setError

function getTimeEllapsedString(timeLeft) {
	if (timeLeft <= MINIMAL_SIGNIFICANT_MILLISECONDS) answer = "";
	else {
		days = parseInt(timeLeft / (1000 * 3600 * 24));
		hours = parseInt((timeLeft % (1000 * 3600 * 24)) / (1000 * 3600));
		minutes = parseInt((timeLeft - (days * 1000 * 3600 * 24) - (hours * 1000 * 3600)) / (60 * 1000)); 
		seconds = parseInt((timeLeft - (days * 1000 * 3600 * 24) - (hours * 1000 * 3600) - (minutes * 1000 * 60)) / (1000)) 
		answer = getTimeField(days,"day") + (hval=getTimeField(hours,"hour")) + (mval=getTimeField(minutes,"min")); 
		if (hval=="") {
			answer += getTimeField(seconds,"sec");
		}
	}
	return answer;
}//getTimeEllapsedString

function getTimeField(value,suffix) {
	if (value > 0) {
		plural = "";
		if (value > 1) plural = "s";
		return (value + " " + suffix + plural + " ");
	}
	else return "";
}//getTimeField

function sortByName(arg1, arg2) {
	if (arg1.product.titleHash < arg2.product.titleHash) {
		return -1;
	} else if (arg1.product.titleHash > arg2.product.titleHash) {
		return 1;
	} else {
		return 0;
	}
}//sortByName

function sortByOffer(arg1, arg2) {
	if (!DO_NOT_COMINGLE) {
		if (arg1.price && arg2.price) {
			return (arg1.price - arg2.price);
		} else {
			return 0;
		}
	} else {
		rank = arg1.product.shoppingResult.partnerRank - arg2.product.shoppingResult.partnerRank;
		if (rank == 0) {
			rank = (arg1.price - arg2.price);
		}
		return rank;
	}
}//sortByOffer

function sortByPrice(arg1, arg2) {
	p1 = p2 = 0;

	if (
			arg1.product
			&&
			arg1.product.pricing
			&&
			arg1.product.pricing.offers
			&&
			arg1.product.pricing.offers[0]
			&&
			arg1.product.pricing.offers[0].price
			&&
			!isNaN(arg1.product.pricing.offers[0].price)
		) {
			p1 = arg1.product.pricing.offers[0].price;
		}
		
		if (
			arg2.product
			&&
			arg2.product.pricing
			&&
			arg2.product.pricing.offers
			&&
			arg2.product.pricing.offers[0]
			&&
			arg2.product.pricing.offers[0].price
			&&
			!isNaN(arg2.product.pricing.offers[0].price)
		) {
			p2 = arg2.product.pricing.offers[0].price;
		}
	
	return (p1 - p2);
}//sortByPrice

function addTextListItem(listRef,theText) {
	newListItem = $e("span");
	newListItem.appendChild($t(theText));
	listRef.appendChild(newListItem);
}//addTextListItem

function getLink(targetUrl) {
	newLink = $("h_link").cloneNode(true);
	if (targetUrl) {
		newLink.href = targetUrl.replace(/[ \r\n\t\f\s]+/g,'');
	}
	newLink.removeAttribute("id");
	return newLink;
}//getLink

function getCleanString(s) {
	return (s.replace(/\/.?/g,' / ').replace(/\,/g,', ').replace(/\+/g,' + '));
}//getCleanString()

function getTruncatedString(s,l,skipTruncate) {
	if (skipTruncate || (s.length <= l)) {
		return s;
	} else {
		return (s.substring(0,(l - 5 ))) + " ...";
	}
}//getTruncatedString

function getPriceFloat(s) {
	s = s.replace(/[ \,\$]+/g,'');
	s = parseFloat(s);
	return s;
}//getPriceFloat

function getFormattedPrice(p) {
	//1,234,567.12
    //0 123 456
    //123,456,789.20
	p = p + 0.001;
	p = p + "";
	decIndex=p.indexOf(".")
	intpart = p.substring(0,decIndex);
	
	if (intpart.length > 3) {
		formattedIntPart = new StringBuffer();
		ccount = intpart.length - 1;
		poscount = 1;
		while((c=intpart.charAt(ccount))) {
			formattedIntPart.append(c);
			if	( 
					(ccount != 0)
					&&
					((poscount % 3) == 0)
				) {
				formattedIntPart.append(",");
			}
			ccount--;
			poscount++;
		}//loop thru int chars
		formattedIntPart.__strings__.reverse();
		formattedIntPart = formattedIntPart.toString();
	} else {
		formattedIntPart = intpart;
	}
	decpart = p.substring(decIndex + 1,decIndex + 3);
	return (formattedIntPart + "." + decpart);
}//getFormattedPrice

function getCurrency(cid) {
	return CURRENCIES[cid];
}//getCurrency

function zoomImage(visualContainer) {
	contentRef = visualContainer.referenceToContentNode;
	r = visualContainer.referenceToResultObject;
	if (contentRef) {
		viewer = $$mc("div","viewer",visualContainer.parentNode.parentNode.parentNode.parentNode)[0];
		if (viewer.firstChild) viewer.removeChild(viewer.firstChild);
		img = viewer.appendChild($e("img"));

		widthToUse = null;
		heightToUse = null;

		if (r.product.visual.large_url) {
			img.setAttribute("src",r.product.visual.large_url);
			if (r.product.visual.large_width) {
				widthToUse = r.product.visual.large_width;
				heightToUse = r.product.visual.large_height;
			}
		} else if (r.product.visual.medium_url) {
			img.setAttribute("src",r.product.visual.medium_url);
			if (r.product.visual.medium_width) {
				widthToUse = r.product.visual.medium_width;
				heightToUse = r.product.visual.medium_height;
			}
		}
		
		img.setAttribute("title",r.product.title);
		
		dims = getScaledDownDimensions(widthToUse, heightToUse);
		
		if (dims) {
			img.setAttribute("width",dims[0]);
			img.setAttribute("height",dims[1]);
		}
		viewer.style.visibility="visible";
	}//if content node found
}//zoomImage

function getScaledDownDimensions(width,height) {
	if (width && height && !isNaN(width) && !isNaN(height)) {
		currentWidth = MAX_IMAGE_WIDTH;
		currentHeight = getProportionalHeight(width,height,currentWidth);
		
		while (!((currentWidth <= MAX_IMAGE_WIDTH) && (currentHeight <= MAX_IMAGE_HEIGHT))) {
			if (currentHeight > MAX_IMAGE_HEIGHT) {
				currentHeight -= 10;
				currentWidth = getProportionalWidth(width,height,currentHeight);
			} else if (currentWidth > MAX_IMAGE_WIDTH) {
				currentWidth -= 10;
				currentHeight = getProportionalHeight(width,height,currentWidth);
			}
		}//loop as long as we haven't reached dimensions within allowed bounds >;o
		
		return [currentWidth,currentHeight];
	} else {
		return null;
	}
}//getScaledDownDimensions

function getProportionalHeight(refWidth, refHeight, newWidth) {
	newHeight = ((refHeight * newWidth) / refWidth);
	return parseInt(newHeight);
}//getProportionalHeight

function getProportionalWidth(refWidth, refHeight, newHeight) {
	newWidth = ((refWidth * newHeight) / refHeight);
	return parseInt(newWidth);
}//getProportionalWidth

/* *** start views *** */

function showError(message) {
	goToBasicView();
	$("search-input").focus();
}//showError

function goToBasicView() {
	clearStatus();
	if ($("interface").className != "minimized") {
		$("interface").className="minimized";
		$("pick").style.visibility="hidden";
		$("buy").style.visibility="hidden";
		if (window.widget)
			window.resizeTo(346,85);
	}
}//goToBasicView

function goToListMode() {
	if ($("interface").className != "withList") {
		$("interface").className="withList";
		$("pick").style.visibility="visible";
		$("buy").style.visibility="hidden";
		if (window.widget)
			window.resizeTo(346,440);
	}
	
}//goToListMode

function goToDetailMode() {
	clearStatus();
	if ($("interface").className != "detailMode") {
		$("interface").className="detailMode";
		$("buy").style.visibility="visible";
		if (window.widget)
			window.resizeTo(620,440);
	}
	
}//goToDetailMode

/* *** end views *** */

function checkConfig() {
	now = (new Date()).getTime();
	if	(
			!glob_lastConfigCheckTimeStamp
			||
			(now - glob_lastConfigCheckTimeStamp) > CONFIG_CHECK_INTERVAL_MILLIS
		) {
			getConfigUpdate();
			glob_lastConfigCheckTimeStamp = now;
	}
}//checkConfig

function getConfigUpdate() {
	getResultsFromNetwork(CONFIG_CHECK_URL,true);
}//getConfigUpdate

function processConfigUpdate() {
	status_code = glob_req.status;
	if (status_code == 200) {
		configVersion = parseFloat(getTextData($$(glob_req.responseXML,"current-version")));
		if	(
				!isNaN(configVersion)
				&&
				(configVersion > THIS_SOFTWARE_VERSION)
			) {
				glob_widgetIsOutDated = true;
				glob_widgetUpgradeMessageHtmlString = getTextData($$(glob_req.responseXML,"upgrade-message"));
				glob_widgetUpgradeUrl = getTextData($$(glob_req.responseXML,"download-url"));
				showUpgradeNotice();
		} else {
			resetConfigStatus();
		}
	}//if status is 200, vs 404 or 302
	else {
		resetConfigStatus();
	}
}//processConfigUpdate

function showUpgradeNotice() {
	goToListMode();
	setError(null,null,glob_widgetUpgradeMessageHtmlString, glob_widgetUpgradeUrl);
}//showUpgradeNotice

function resetConfigStatus() {
	glob_widgetIsOutDated = false;
	glob_widgetUpgradeMessageHtmlString = null;
	glob_widgetUpgradeUrl = null;
}//resetConfigStatus

function hideBack() {
	clearCache();
	front = $("front");
	back = $("back");
	if (window.widget) {
		widget.prepareForTransition("ToFront");
	}
	back.style.display = "none";
	front.style.display = "block";
	if (window.widget) {
		setTimeout('widget.performTransition();',0);
	}
	goToBasicView();
}//hideBack

function showBack() {
	front = $("front");
	back = $("back");
	goToBasicView();
	if (window.widget) {
		widget.prepareForTransition("ToBack");
	}
	front.style.display = "none";
	back.style.display = "block";
	if (window.widget) {
		setTimeout('widget.performTransition();',0);
	}
}//showBack

glob_doneButton = null;
glob_infoButton = null;

function setupFrontBack() {
	glob_doneButton = new AppleGlassButton($("doneButton"), "Done", hideBack);
	glob_infoButton = new AppleInfoButton($("infoButton"), $("front"), "black", "black", showBack);
}//setupFrontBack

function initWidget() {
	checkConfig();
	setupFrontBack();
	getSavedPreferences();
}//init the widget

function handleMouseUp(event) {
e = getEvent(event);
eL = getEventElement(e);
var item = null;

selectOfferRow = true;

if (offerCell = isWithinNode(eL,null,"priceInfo")) {
	goToOffer(offerCell.offer);
}//user clicked in price Info cell

if (
		(item = isWithinNode(eL,null,null,ITEM_SELECT_TAG_NAME,null)) 
		&&
		(lv = isWithinNode(eL,null,"listView",null,null))
		&&
		selectOfferRow
	) {
		
		/* we just clicked on a list item */
		/* that lives somewhere within an element that's a listView */
		/* yes, isWithinNode truly rocks */
		//alert("calling displayitem");
		displayItem(item, true);
	}
}//handleMouseUp

function handleKeyDown(event) {
e = getEvent(event);
eL = getEventElement(e);

	if (!$("search-input").isFocused && (!$("suggestionMenu") || ($("suggestionMenu") && !$("suggestionMenu").isFocused))) {
		kc = e["keyCode"];
		if ((kc == 40) || (kc == 39)) {
			freezeEvent(e);
			selectNextItem();
		} else if ((kc == 38) || (kc == 37)) {
			freezeEvent(e);
			selectPreviousItem();
		}
	}//only trap up/down/left/right arrow key actions if the user is not in the input box.
}//handleKeyDown

if (document.addEventListener) {
	document.addEventListener("mouseover",handleContextualMenuMouseOver, false);
	document.addEventListener("mouseup", handleMouseUp, false);
	document.addEventListener("keydown", handleKeyDown, false);
} else {
	document.onmouseover = handleContextualMouseOver;
	document.onmouseup = handleMouseUp;
	document.onkeydown = handleKeyDown;
}